--- linux/fs/isofs/inode.c.iso9660opt	Sat Jul 14 13:39:05 2001
+++ linux/fs/isofs/inode.c	Sun Jul 15 18:52:22 2001
@@ -295,6 +295,8 @@
 	popt->sbsector=-1;
 	if (!options) return 1;
 	for (this_char = strtok(options,","); this_char; this_char = strtok(NULL,",")) {
+		if (!this_char)
+		    return 1;
 	        if (strncmp(this_char,"norock",6) == 0) {
 		  popt->rock = 'n';
 		  continue;
@@ -340,13 +342,13 @@
 			else if (!strcmp(value,"acorn")) popt->map = 'a';
 			else return 0;
 		}
-		if (!strcmp(this_char,"session") && value) {
+		else if (!strcmp(this_char,"session") && value) {
 			char * vpnt = value;
 			unsigned int ivalue = simple_strtoul(vpnt, &vpnt, 0);
 			if(ivalue < 0 || ivalue >99) return 0;
 			popt->session=ivalue+1;
 		}
-		if (!strcmp(this_char,"sbsector") && value) {
+		else if (!strcmp(this_char,"sbsector") && value) {
 			char * vpnt = value;
 			unsigned int ivalue = simple_strtoul(vpnt, &vpnt, 0);
 			if(ivalue < 0 || ivalue >660*512) return 0;
@@ -396,7 +398,7 @@
 		    break;
 		  }
 		}
-		else return 1;
+		else continue;
 	}
 	return 1;
 }
